@echo off
rem
rem Copy of consolidated patch
rem
rem Usage:
rem   CMPatchCopy
rem
rem   notice)
rem    No parameter
rem

setlocal enabledelayedexpansion

rem	-- Folder name of patch library
set	CurrDir=%~dp0
set	PatchFolder32=For32bitOS
set	PatchFolder64=For64bitOS
rem	-- Patch archive folder, Backup folder
set	PatchArc=_PatchArc
set	PatchBkup=_PatchBac
set logfname=""
rem	-- UserID, Authority
set LEVEL=""
set	USER=""
rem	-- PC Environment (32 or 64bit)
set PCXxx=""
rem	-- Destination drive, Version
set	InstDrive=""
set	InstVer=""
rem	-- Base version of patch / Version of patch
set	BaseVer=""
set	PatchVer=""
set	PatchVerArc=""
rem	-- CADmeister Installation Folder
rem	CMDIR=""
rem	-- Error messages
set	UIDErr="Error getting user ID"
set	AdminErr="Please login as an administrator and execute it."
set	PrmErr="Incorrect contents of parameter file."
set	CMInstErr="The CADmeister is not installed."
set	BaseVerErr="The CADmeister and patch versions do not match."
set	PatchOrderErr="Wrong patch order."
set	SamePatchErr="This version of the patch has been applied."
set	LatestPatchErr="Last patch information is unknown."
set	CMJikkoErr="Please exit CADmeister (Include Tools) and try again."
set	PatchCopyErr="An error occurred while copying the patch."
rem	CopySuccess="7 files copied"

rem ----------------------------------------------------------------------------
rem **Obtain the date and time
for /f "usebackq tokens=*" %%a in (`powershell -Command "(Get-Date).AddMonths(-1).ToString('yyyy/MM/dd')"`) do @set datestring=%%a
set DATE_Y=%datestring:~0,4%
set DATE_M=%datestring:~5,2%
set DATE_D=%datestring:~8,2%
set TIME_H=%TIME:~0,2%
set TIME_M=%TIME:~3,2%
set TIME_S=%TIME:~6,2%
set Date8=%DATE_Y%%DATE_M%%DATE_D%
set Time6=%TIME_H%%TIME_M%%TIME_S%
if "%Time6:~0,1%" EQU " " set Time6=0%Time6:~1%
set DATETIME=%Date8%_%Time6%

	echo off
rem **Get Login User
	for /f "tokens=2 delims=\ " %%u in ( 'whoami' ) do (
		set USER=%%u
	)
	if "%USER%" EQU "" (
	echo %UIDErr%
	echo %DATETIME%  >  noname_%DATETIME%.log
	echo UIDErr     >>  noname_%DATETIME%.log
	endlocal
	exit /b 1
	)

@echo off
rem **Check if the CADmeister.exe(and or tools) running (2019/03/13)
	for /f "tokens=1" %%t in ('tasklist ^| find "CADmeister.exe"') do (
	if %%t equ CADmeister.exe (
		echo %CMJikkoErr%
		echo %USER%_%DATETIME% %CMJikkoErr%  >  %USER%_%DATETIME%.log
		endlocal
		exit /b 1
	) 
	)
	for /f "tokens=1" %%t in ('tasklist ^| find "JobManager.exe"') do (
	if %%t equ JobManager.exe (
		echo %CMJikkoErr%
		echo %USER%_%DATETIME% %CMJikkoErr%  >  %USER%_%DATETIME%.log
		endlocal
		exit /b 1
	) 
	)
	for /f "tokens=1" %%t in ('tasklist ^| find "BatchTranslator.exe"') do (
	if %%t equ BatchTranslator.exe (
		echo %CMJikkoErr%
		echo %USER%_%DATETIME% %CMJikkoErr%  >  %USER%_%DATETIME%.log
		endlocal
		exit /b 1
	) 
	)

rem **Checking if you are running as an administrator
	for /f "tokens=3 delims=\ " %%i in ( 'whoami /groups^|find "Mandatory"' ) do (
		set LEVEL=%%i
	)
	if "%LEVEL%" NEQ "High" (
	echo %AdminErr%
	echo %USER%_%DATETIME% %AdminErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 2
	)

rem	openfiles > NUL 2>&1
rem	if NOT %errorlevel% EQU 0 (
rem	echo %AdminErr%
rem	echo %USER%_%DATETIME% %AdminErr%  >  %USER%_%DATETIME%.log
rem	endlocal
rem	exit /b 2
rem	)

@echo off
rem **Get Destination Dir
	for /f "tokens=1,3" %%A in ('reg query "HKLM\SOFTWARE\Nihon Unisys Excelutions\CADMEISTER" /v INSTDIR ^|^| echo NG') do (
	if %%A equ NG (
		echo %CMInstErr%
		echo %USER%_%DATETIME% %CMInstErr%  >  %USER%_%DATETIME%.log
		endlocal
		exit /b 3
	) else (
	set  InstDrive=%%B
	)
)

rem **Get base version of CADmeister
rem	for /f "tokens=1,3" %%A in ('reg query "HKLM\SOFTWARE\Nihon Unisys Excelutions\CADMEISTER\Currentversion" /v BASIC ^|^| echo NG') do (
	for /f "tokens=1,3" %%A in ('reg query "HKLM\SOFTWARE\Nihon Unisys Excelutions\CADMEISTER\Currentversion" ^|^| echo NG') do (
	if %%A equ NG (
		echo %CMInstErr%
		echo %USER%_%DATETIME% %CMInstErr%  >  %USER%_%DATETIME%.log
		endlocal
		exit /b 4
	) else (
	set  InstVer=%%B
	)
)
rem echo %InstDrive%
rem echo %InstVer%

rem **Check if PC is 32 bit or 64 bit
	if exist "%ProgramFiles(x86)%" (
		set  PCXxx=X64
	) else (
		set  PCXxx=X32
	)

rem	**Get Supplied Patch Version (1)
	for /f "tokens=1" %%p in (%CurrDir%CMUPprm.txt) do set tmpPBaseVer=%%p
	set	BaseVer=%tmpPBaseVer%

	rem echo %BaseVer%
	if	 %BaseVer%=="" (
		echo %PrmErr%
      	echo %USER%_%DATETIME% %PrmErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 5
	)

rem	**Get Supplied Patch Version (2)
	for /f "tokens=2" %%p in (CMUPprm.txt) do set tmpPatchVer=%%p
	set	PatchVer=%tmpPatchVer%

	if	 %PatchVer%=="" (
		echo %PrmErr%
      	echo %USER%_%DATETIME% %PrmErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 6
	)

rem	**CADmeister installation folder, patch archive folder
	set CMDIR=%InstDrive%CRESTAM\
	set PatchArc=%CMDIR%%PatchArc%

	echo off
rem	**Obtaining a previously applied patch version
	rem	Verify that the folder created after the patch is run exists(\CRESTAM\_PatchArc). If not, new patches.
	rem	In addition, find the log file with the latest update date and time.

	if exist %PatchArc% (
		if exist %PatchArc%\*.log (
		for /F "tokens=1* delims=" %%a in ('dir /b /O:D %PatchArc%\*.log') do set logfname=%%a
		) else (goto Nextst)
	) else (set logfname=""
	)
:Nextst
	rem	The most recent log file. New patch if log file does not exist

	rem echo %logfname%
	if %logfname%=="" (goto NewPatch)

	rem	Get previous patch version if latest log file exists

	if exist %PatchArc%\%logfname% (
		for /F "tokens=2  delims=:" %%i in ( 'findstr "Patch-version" %PatchArc%\%logfname%' ) do set PatchVerArc=%%i

	rem	 The latest patch version. Abort if the log file exists and the patch version cannot be obtained.
	rem echo %PatchVerArc%
	)
	if %PatchVerArc%=="" (
		echo %LatestPatchErr%
    	echo %USER%_%DATETIME% %LatestPatchErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 7
	)

rem	**Check if installed CADmeister and patch versions match
:NewPatch
	echo off

	if	 %InstVer% NEQ %BaseVer% (
		echo %BaseVerErr%
    	echo %USER%_%DATETIME% %BaseVerErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 8
	)

rem	**Check whether the installed patch version (A) older than the patch version (B) you are about to apply
	rem A=B FNot applicable (Already Applied)
	rem A>B FNot applicable (Older versions are not applicable. Already Applied)
	rem A<B FApplicable (Already implemented)
	rem A=""FApplicable (Not implemented in the past)
	rem equ(==) neq(!=) lss(<) leq(<=) gtr(>) geq(>=)

	if	%PatchVerArc% equ "" (goto ApplyPatch)
	if	%PatchVerArc% equ %PatchVer% (
		echo %SamePatchErr%
    	echo %USER%_%DATETIME% %SamePatchErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 9
	)
	if	%PatchVerArc% gtr %PatchVer% (
		echo %PatchOrderErr%
    	echo %USER%_%DATETIME% %PatchOrderErr%  >  %USER%_%DATETIME%.log
	endlocal
	exit /b 9
	)

:ApplyPatch
rem **Creating a Working Folder (For Backup)
rem	md  %CMDIR%%USER%%DATETIME%%PatchBkup%

@echo off
echo **Copy the patch under the following conditions
echo.
echo Login User:%USER%
echo Permission Level:%LEVEL%
echo PC Environment:%PCXxx%
echo Date and time of execution:%DATETIME%
echo Installed CADmeister Version:%InstVer%
echo CADmeister installation folder:%CMDIR%
echo Patched To Version:%BaseVer%
echo Patch-version:%PatchVer%
echo.
echo ** To cancel, key in [Ctrl + C]. **
pause

@echo off
rem echo %CurrDir%

rem **Check the PC environment and determine the folder to copy.
	call :OUTPUT

	if %PCXxx%==X32 (
		xcopy /c /e /i /y  %CurrDir%%PatchFolder32%\CRESTAM %InstDrive%CRESTAM >> %CurrDir%%USER%_%DATETIME%.log
	) else if %PCXxx%==X64 (
		xcopy /c /e /i /y  %CurrDir%%PatchFolder64%\CRESTAM %InstDrive%CRESTAM >> %CurrDir%%USER%_%DATETIME%.log
	)

rem	**Archive patch version
	if not exist %PatchArc% (
	 md %PatchArc%
	)
rem	copy /y %USER%_%DATETIME%.log %PatchArc% > nul
	move /y *.log %PatchArc% > nul

echo **Patching completed successfully. Close the command screen.**

	exit /b %RET%

	rem	xcopy options
	rem	/cFIgnore errors when copying
	rem	/eFCopy entire directory even if files do not exist
	rem	/iFCreate a new directory if the destination directory does not exist
	rem	/yFDo not prompt for overwrite if a file with the same name exists

rem ----------------------------------------------------------------------------
:OUTPUT
rem	**Log output when the check is successful

	set RET=0
	echo Login User:%USER%                     >  %USER%_%DATETIME%.log
	echo UAC:%LEVEL%                           >> %USER%_%DATETIME%.log
	echo PC Type:%PCXxx%                       >> %USER%_%DATETIME%.log
	echo Date and time of execution:%DATETIME% >> %USER%_%DATETIME%.log
	echo Current folder:%CurrDir%              >> %USER%_%DATETIME%.log
	echo Installation Drive:%InstDrive%        >> %USER%_%DATETIME%.log
	echo Installation Verersion:%InstVer%      >> %USER%_%DATETIME%.log
	echo iIstallation folder:%CMDIR%	       >> %USER%_%DATETIME%.log
	echo Base version of patch:%BaseVer%       >> %USER%_%DATETIME%.log
	echo Patch-version:%PatchVer%              >> %USER%_%DATETIME%.log
	exit /b %RET%

	rem	** Since the "Patch version:" string above is referenced for judgment, it is not possible to change, delete or register the same value. **
